package oracle.forms.fd;

import java.awt.BasicStroke;
import java.awt.Color;
import java.awt.Cursor;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Random;
import java.util.StringTokenizer;
import javax.swing.JFrame;
import java.awt.BorderLayout;
import javax.swing.JPanel;
import javax.swing.JLabel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JSpinner;
import javax.swing.JTextArea;
import javax.swing.JToolBar;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.JOptionPane;
import javax.swing.SpinnerDateModel;
import javax.swing.SpinnerModel;
import javax.swing.SpinnerNumberModel;
import javax.swing.UIManager;
import javax.swing.ActionMap;
import javax.swing.BorderFactory;
import javax.swing.JTextField;
import javax.swing.border.BevelBorder;
import javax.swing.border.Border;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

public class Build extends JFrame implements MouseListener, MouseMotionListener, KeyListener, ActionListener, ChangeListener
{
  private JButton buttonHelp = new JButton();
  private JButton buttonTest = new JButton();  
  private JButton buttonClose = new JButton();
  private JButton buttonOpen = new JButton();
  private JButton barr = new JButton();
  private JButton ball = new JButton();
  private JLabel statusBar = new JLabel();
  private JLabel lifeBar = new JLabel();
  private JMenuItem menuHelpAbout = new JMenuItem();
  private JMenu menuHelp = new JMenu();
  private JMenuItem menuFileExit = new JMenuItem();
  private JMenu menuFile = new JMenu();
  private JMenuItem menuFileSave = new JMenuItem();
  private JMenuItem menuFileClear = new JMenuItem();  
  private JMenuItem menuOptionSpeedUp = new JMenuItem();
  private JMenuItem menuOptionSpeedDown = new JMenuItem();  
  private JMenu menuOption = new JMenu();    
  private JMenuBar menuBar = new JMenuBar();
  private JPanel panelCenter = new JPanel();
  private JPanel toolPanel = new JPanel();  
  private BorderLayout layoutMain = new BorderLayout();
  private int x=0, y=0, w=0, h=0, iSens = -1 ;
  private int iNbLines=10, iNbCols= 15, iMaxCols=15, iMaxLines=15 ;
  private int iRaqSize = 60 ;
  private int iTotBricks=0; 
  private int iCurrentLevel=1, iHits=1;
  private int iCurLig=0, iCurCol=0 ;
  private int iBrickWidth=52, iBrickHeight=20;
  private boolean bTest=false, bStart = false, bLog = true ;
  private int posX=0, posY=0, incX=-1, incY=-5, valincX=0 ;
  private ActionMap actionMap1 = new ActionMap();
  private Dimension panelSize, screenSize, frameSize ;
  private Color raqColor = new Color(0,0,204);
  private Color balColor = new Color(255,255,0);
  private Color bgColor  = new Color(240,255,240);  
  private  brickT[][] vBricks  = new brickT[iMaxLines][iMaxCols] ;  
  private String  sCfgFile = "brickwall.cfg" ;
  private String selectTool="1hit",sBrick="";
  private JTextField JTnumPanel = new JTextField() ;
  private Graphics graphic = null ;
  private String[][]tabLines = new String[99][225] ;
  private int iSpeed = 10 ;
  private SpinnerModel SPmodel = new SpinnerNumberModel(1, 1, 99, 1);
  private JSpinner levelSpinner = new JSpinner(SPmodel);
	private BufferedImage bi;
	private Graphics2D big;
  private boolean firstTime = true ;
  private Rectangle area;

  public Build()
  {
    try
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }

  }

  private void jbInit() throws Exception
  {
    brick b ;
    this.setJMenuBar(menuBar);
    //this.getContentPane().setLayout(layoutMain);
    panelCenter.setLayout(null);
    toolPanel.setLayout(null);
    this.setSize(new Dimension(890, 640));
    this.setTitle("Build Wall");
    menuFile.setText("File");
    menuFileExit.setText("Exit");
    menuFileExit.addActionListener(new ActionListener()
      {
        public void actionPerformed(ActionEvent ae)
        {
          fileExit_ActionPerformed(ae);
        }
      });
    menuFileSave.setText("Save level");
    menuFileSave.addActionListener(new ActionListener()
      {
        public void actionPerformed(ActionEvent ae)
        {
          fileSave_ActionPerformed(ae);
        }
      });
    menuFileClear.setText("Clear level");
    menuFileClear.addActionListener(new ActionListener()
      {
        public void actionPerformed(ActionEvent ae)
        {
          fileClear_ActionPerformed(ae);
        }
      });            
    menuHelp.setText("Help");
    menuHelpAbout.setText("About");
    buttonHelp.addActionListener(new ActionListener()
      {
        public void actionPerformed(ActionEvent ae)
        {
          helpAbout_ActionPerformed(ae);
        }
      });    
    menuHelpAbout.addActionListener(new ActionListener()
      {
        public void actionPerformed(ActionEvent ae)
        {
          helpAbout_ActionPerformed(ae);
        }
      });
    
    menuOption.setText("Options");
    menuOptionSpeedUp.setText("Speed Up");      
    menuOptionSpeedUp.addActionListener(new ActionListener()
      {
        public void actionPerformed(ActionEvent ae)
        {
          if(iSpeed > 1) iSpeed-=5;
        }
      });    
    menuOptionSpeedDown.setText("Speed Down");  
    menuOptionSpeedDown.addActionListener(new ActionListener()
      {
        public void actionPerformed(ActionEvent ae)
        {
          iSpeed+=5;
        }
      });      
    statusBar.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED)) ;
    statusBar.setText("Click the mouse to lauch the ball");
    lifeBar.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED)) ;
    screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    frameSize = this.getSize();    
    if (frameSize.height > screenSize.height)
    {
      frameSize.height = screenSize.height;
    }
    if (frameSize.width > screenSize.width)
    {
      frameSize.width = screenSize.width;
    }
    this.setLocation((screenSize.width - frameSize.width) / 2, (screenSize.height - frameSize.height) / 2);
    log(frameSize.width+","+frameSize.height);
    // add barr on panel
    panelCenter.add(barr);
    panelCenter.add(ball);
    panelCenter.setPreferredSize(new Dimension(790,560));
    panelCenter.setBackground(bgColor);
    panelCenter.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED)) ;
    toolPanel.setPreferredSize(new Dimension(100,560));
    toolPanel.setBackground(Color.LIGHT_GRAY);
    toolPanel.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED)) ;
    panelSize = panelCenter.getPreferredSize();    
    log(panelSize.width+","+panelSize.height);
    x = panelSize.width/2 ;
    y = panelSize.height-40 ;
    // barr
    barr.setBounds(1,1,iRaqSize,12);    
    barr.setLocation(x,y);
    barr.setBackground(raqColor) ;
    barr.setVisible(false);
    // ball
    ball.setBounds(1,1,10,10);
    ball.setLocation(x+(iRaqSize/2), y-11);
    ball.setBackground(balColor);
    ball.setBorder(BorderFactory.createLineBorder(new Color(255,95,17))) ;
    ball.setVisible(false);
    posX = x+(iRaqSize/2) ;
    posY = y-11 ;
    this.addKeyListener(this);    
    panelCenter.addMouseMotionListener(this);
    panelCenter.addMouseListener(this);
    // File menu
    menuFile.add(menuFileClear);
    menuFile.addSeparator();
    menuFile.add(menuFileSave);
    menuFile.addSeparator();
    menuFile.add(menuFileExit);    
    // Option menu
    menuOption.add(menuOptionSpeedUp);
    menuOption.add(menuOptionSpeedDown);
    // bar menu
    menuBar.add(menuFile);
    menuBar.add(menuOption);
    menuHelp.add(menuHelpAbout);
    menuBar.add(menuHelp);
    this.getContentPane().add(statusBar, BorderLayout.SOUTH);
    this.getContentPane().add(toolPanel, BorderLayout.EAST);
    this.getContentPane().add(panelCenter, BorderLayout.CENTER);
    
    readFile();
    readFile(1);

    this.setFocusable(true);
    this.setVisible(true); //Display the window.

    BuildToolPanel() ;
    vBricks[0][0].requestFocus();
    this.setTitle("WallBrick Builder  [level "+iCurrentLevel+"]");
  
    testmove();
      

  }

  // exit
  void fileExit_ActionPerformed(ActionEvent e)
  {
    System.exit(0);
  }
  // save
  void fileSave_ActionPerformed(ActionEvent e)
  {
    iCurrentLevel = Integer.parseInt(levelSpinner.getValue().toString()) ;
    writeFile(iCurrentLevel);
  }  
  // clear
  void fileClear_ActionPerformed(ActionEvent e)
  {
    BuildWall();
  }  

  /***************
   *  ball move  *
   **************/
  void testmove()
  {
     int iPos=0 ;
     int iGridX, iGridY ;
     int iValue = 0, iVSens = 0, iHSens  = 0 ;
     int iOldX=0, iOldY=0 ;
     Rectangle bLeft, bRight ;
     Point pt ;
     boolean bClean=false ;
     while(true)
     {
      if( bStart )
      {
      if( posY < 5 )
       {
          iSens *= -1 ;
          incY =  5 * iSens ; // down
       }
      else if( posY > (y-5) )
       {
          if((posX+5 < barr.getX()) || (posX-5 > barr.getX()+60))
          {
            // lost the ball !!!
            bStart = false ;
            posX = barr.getX()+(iRaqSize/2) ;
            posY = y-11 ;
            incX = 0 ;
            valincX = 0 ;            
            ball.setLocation(posX, posY);            
            log("lost the ball ! sart="+bStart);                
          }
          else
          {
            iSens *= -1 ;
            iPos = posX - barr.getX() ;
            if( iPos >= 0 && iPos <= 5 ) valincX = -4 ;
            else if( iPos >=  6 && iPos <= 11 ) valincX = -3 ;
            else if( iPos >= 12 && iPos <= 19 ) valincX = -2 ;
            else if( iPos >= 20 && iPos <= 27 ) valincX = -1 ;
            else if( iPos >= 28 && iPos <= 31 ) valincX = 0 ;
            else if( iPos >= 32 && iPos <= 39 ) valincX = 1 ;
            else if( iPos >= 40 && iPos <= 47 ) valincX = 2 ;
            else if( iPos >= 48 && iPos <= 53 ) valincX = 3 ;
            else if( iPos >= 54 ) valincX = 4 ;

            incY =  5 * iSens ;
          }
       }
       if( posX < 1 || posX+10 > panelSize.width )
        {
          valincX *= -1 ;
          incX = valincX ;
          if( posX < 1 ) posX = 10 ;
          else posX = panelSize.width-10 ;
        }
       else incX = valincX ; 
       posX += incX ;
       if( posX != iOldX ) iOldX = posX ;
       if(bStart) posY += incY ;
       /****************************
       * is there a brick hitted ? *
       ****************************/ 
       iGridX = posX / iBrickWidth ;
       iGridY = posY / iBrickHeight ;
       // if we are inside the brick matrix
       if( (iGridY >= 0 && iGridX >= 0) && (iGridY < iMaxLines && iGridX < iMaxCols))
       {
          // left border
          bLeft = new Rectangle(vBricks[iGridY][iGridX].x-2,vBricks[iGridY][iGridX].y+2,4,vBricks[iGridY][iGridX].h-4) ;
          // right border
          bRight  = new Rectangle(vBricks[iGridY][iGridX].x+vBricks[iGridY][iGridX].w-2,vBricks[iGridY][iGridX].y+2,4,vBricks[iGridY][iGridX].h-4) ;
          pt = new Point(posX, posY) ;
          // type 0 : brick is null   type 9 : brick is unbrokable
          if ( (vBricks[iGridY][iGridX].iType > 0 && vBricks[iGridY][iGridX].iType < 9) )
               //&& (iGridX != iOldX && iGridY != iOldY ) )
          {
            if(vBricks[iGridY][iGridX].iHits > 1)
            {
              // brigth the brick color and decrease the counter
              if(vBricks[iGridY][iGridX].iType != 6)
                 vBricks[iGridY][iGridX].color = vBricks[iGridY][iGridX].color.brighter() ;
              //vBricks[iGridY][iGridX].setBackground(vBricks[iGridY][iGridX].color) ;
              vBricks[iGridY][iGridX].setText("");
              vBricks[iGridY][iGridX].iHits-- ;
            }
            else 
            {
              // hide the brick
              //vBricks[iGridY][iGridX].setVisible(false) ;
              vBricks[iGridY][iGridX].setBackground(Color.WHITE);
              bClean = true ;
            }
            // glue brick
            if(vBricks[iGridY][iGridX].iType == 7) iSpeed *= 3 ;
            
          }
          // change the direction
          if(vBricks[iGridY][iGridX].iType == 6)
          { // random brick
            iValue = myRandomInteger(0,5);
            iVSens = myRandomInteger(0,1);
            iHSens = myRandomInteger(0,1);
            if(iHSens == 0) valincX = iValue * -1 ;
            else            valincX = iValue ;
            if(iVSens == 0) iSens *= -1 ;
            incY =  5 * iSens ;
          }
         // is it a border ?
          else if (vBricks[iGridY][iGridX].iType > 0)
          {
             if( (bLeft.contains(pt) || bRight.contains(pt)) && (incX != 0) )  
               {
                  // up ?
                  if( iSens < 0)
                  {
                    // left side
                    if(bLeft.contains(pt) && incX > 0)
                    {
                      // nothing on the up/left ?
                      if( (iGridX > 0) && 
                        (((iGridY > 0) && (vBricks[iGridY-1][iGridX-1].iType == 0)) || (iGridY == 0)) )
                      {
                         valincX *= -1 ;
                         incX = valincX ;    
                      }
                      else // inverse the direction
                      {
                         valincX *= -1 ;
                         incX = valincX ;
                         iSens *= -1 ;
                         incY =  5 * iSens ;
                      }                    
                    }
                    // right side
                    else if(bRight.contains(pt) && incX < 0)
                    {
                      // nothing on the right ?
                      if( (iGridX < iMaxCols) && 
                        (((iGridY > 0) && (vBricks[iGridY-1][iGridX+1].iType == 0)) || (iGridY == 0)) )
                      {
                         valincX *= -1 ;
                         incX = valincX ;    
                      }
                      else // inverse the direction
                      {
                         valincX *= -1 ;
                         incX = valincX ;
                         iSens *= -1 ;
                         incY =  5 * iSens ;
                      }                    
                    }
                  }  
                  else
                  {
                    // down
                    // left side
                    if(bLeft.contains(pt) && incX > 0)
                    {
                      // nothing on the down/left ?
                      if( (iGridX > 0) && 
                        (((iGridY < iMaxLines) && (vBricks[iGridY+1][iGridX-1].iType == 0)) || (iGridY >= iMaxLines)) )
                      {
                         valincX *= -1 ;
                         incX = valincX ;    
                      }
                      else // inverse the direction
                      {
                         valincX *= -1 ;
                         incX = valincX ;
                         iSens *= -1 ;
                         incY =  5 * iSens ;
                      }                    
                    }
                    // right side
                    else if(bRight.contains(pt) && incX < 0)
                    {
                      // nothing on the right ?
                      if( (iGridX < iMaxCols) && 
                        (((iGridY < iMaxLines) && (vBricks[iGridY+1][iGridX+1].iType == 0)) || (iGridY >= iMaxLines)) )
                      {
                         valincX *= -1 ;
                         incX = valincX ;    
                      }
                      else // inverse the direction
                      {
                         valincX *= -1 ;
                         incX = valincX ;
                         iSens *= -1 ;
                         incY =  5 * iSens ;
                      }                    
                    }
                  }
               }
             else // inverse the direction
               {
                  iSens *= -1 ;
                  incY =  5 * iSens ;
               }
          }
       }
       // new ball position
       ball.setLocation( posX-5, posY-5 ) ;
       //repaint(posX-10,posY-10,20,20);
       iOldX = iGridX ;
       iOldY = iGridY ;
       if( bClean )
       {
         vBricks[iGridY][iGridX].iType = 0 ;
         bClean = false ;
       }
       try {
            Thread.sleep(iSpeed);
        } catch (InterruptedException e) {
        }
      }
     }
  }

  // About screen
  void helpAbout_ActionPerformed(ActionEvent e)
  {
    JOptionPane.showMessageDialog(this, new AboutBox(), "About", JOptionPane.PLAIN_MESSAGE);
  }

    /*****************
     *   barr move   *
     ****************/
     public void mouseMoved(MouseEvent e) {
       if( bTest )
       {
        barr.setLocation((e.getX()< panelSize.width-iRaqSize ? e.getX() : panelSize.width-iRaqSize), y);
         if(! bStart) {
           posX = barr.getX()+(iRaqSize/2) ;
           if(posY == y-11) ball.setLocation(posX, y-11);
         }
      }
    }

    public void mouseDragged(MouseEvent e) {
    }

    public void mousePressed(MouseEvent e) {
    }

    public void mouseReleased(MouseEvent e) {
    }

    public void mouseEntered(MouseEvent e) {
    }

    public void mouseExited(MouseEvent e) {
    }

    public void mouseClicked(MouseEvent e) {
       if(bTest)
       {
         bStart = ! bStart ;
         if(bStart) 
         {
           log("Start=true" ) ;
           //statusBar.setText(""+iTotBricks+" bricks to hit       Escape to iconize the window");
         }
         else 
         {
           log("Start=false" ) ;
         } 
       }
    }

  /*******************************
   *  Clear the table of bricks  *
   ******************************/
  private void clearTab()
  {
    int i,j;
    
    for (i=0 ; i<iMaxLines; i++)
    {
      for (j=0 ; j<iMaxCols; j++)
      {
        if( vBricks[i][j] != null)
          panelCenter.remove(vBricks[i][j]);
        vBricks[i][j] = new brickT() ;
      }
    }
    iTotBricks = 0 ;
  }
  
  /*********************
   *   Build the wall  *
   ********************/
  private void BuildWall()
  {
    brickT b ;
    int i,j;
    
    clearTab() ;

    for ( i = 0; i < iMaxLines; i++ )
    {
      for ( j=0; j < iMaxCols; j++) 
      { 
        iTotBricks++ ;
        b = new  brickT((j*iBrickWidth),(i*iBrickHeight),iBrickWidth,iBrickHeight,0,new Color(255,255,255),0);        
        b.setActionCommand("brick-"+i+","+j);
        b.addActionListener(this);
        b.addKeyListener(this);    
        vBricks[i][j] = b ;      
        panelCenter.add(b);
      }    
    }    
    panelCenter.setVisible(false);
    panelCenter.setVisible(true);

  }

  /*******************************
   *   read a particular panel   *
   ******************************/
  private boolean readFile( int iNumPanel )
   {
     BufferedReader fileIn=null;
     String line="", search="" ;
     int lig=0,col=0,x=0,y=0,w=0,h=0,r=0,g=0,b=0 ;
     int color=0, hits=0, type=0 ;
     boolean bCont=true, bFound=false, bOk=false ;
     brickT brk ;
     StringTokenizer st ;
     iTotBricks = 0 ;
     clearTab();
     // Open the file
     log("readFile : try to open : "+sCfgFile ) ;
     try
     {
       fileIn = new BufferedReader( new FileReader(sCfgFile));
     } catch (FileNotFoundException e)
     {
       System.out.println("readFile open error : "+sCfgFile+" not found");
       return false;
     }
       catch (IOException e)
     {
       System.out.println("readFile open error : "+e);
       return false;
     }     
     // read the file
     log("readFile : try to read from : "+sCfgFile+" level "+iNumPanel ) ;
     try
     {
       if(iNumPanel<10) search = "<Panel0"+iNumPanel+">" ;
       else search = "<Panel"+iNumPanel+">" ;
       while((line=fileIn.readLine())!= null && bCont)
       {
         if( line.equalsIgnoreCase("</Panel>") && bFound){  bFound= false; bCont = false ; }
         if( bFound )
         {
           st = new StringTokenizer(line,",");
           lig = Integer.parseInt(st.nextToken()) ;
           col = Integer.parseInt(st.nextToken()) ;
           x = Integer.parseInt(st.nextToken()) ;
           y = Integer.parseInt(st.nextToken()) ;
           w = Integer.parseInt(st.nextToken()) ;
           h = Integer.parseInt(st.nextToken()) ;
           hits = Integer.parseInt(st.nextToken()) ;
           r = Integer.parseInt(st.nextToken()) ;
           g = Integer.parseInt(st.nextToken()) ;
           b = Integer.parseInt(st.nextToken()) ;
           type = Integer.parseInt(st.nextToken()) ;
           brk = new  brickT(x,y,w,h,hits,new Color(r,g,b),type);
           if(type>0 && type<9) brk.setText(""+hits) ;
           brk.setActionCommand("brick-"+lig+","+col);
           brk.addActionListener(this);
           brk.addKeyListener(this);    
           brk.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED, new Color(255,255,255),new Color(0,0,240))) ;
           vBricks[lig][col] = brk ;  
           panelCenter.remove(vBricks[lig][col]);
           panelCenter.add(brk);
           if(type > 0 && type < 9) iTotBricks++ ;
         }
         if( line.equalsIgnoreCase(search)) 
         {
           bFound= true ;         
           bOk = true ;
         }
       }
      log("level "+iNumPanel+" loaded  with "+iTotBricks+" bricks");
      panelCenter.setVisible(false);
      panelCenter.setVisible(true);
      statusBar.setText("Click the mouse to launch the ball       Escape to iconize the window");       
     }catch (Exception e)
     {
       System.out.println("readFile reading error:"+e);
       return false ;
     }
     try
     {
       fileIn.close();
     } catch (Exception e)
     {
       System.out.println("readFile closing error:"+e);
       return false ;
     }
     return bOk ;
   }

  /*******************************************
   *   read all the levels lines in a table  *
   ******************************************/
  private boolean readFile()
   {
     BufferedReader fileIn=null;
     String line="", search="" ;
     int lig=0,col=0,x=0,y=0,w=0,h=0,r=0,g=0,b=0 ;
     int color=0, hits=0, type=0 ;
     boolean bCont=true, bPanelOk=false ;
     brick brk ;
     StringTokenizer st ;
     iTotBricks = 0 ;
     // Open the file
     log("readFile : try to open : "+sCfgFile ) ;
     try
     {
       fileIn = new BufferedReader( new FileReader(sCfgFile));
     } catch (FileNotFoundException e)
     {
       System.out.println("readFile open error : "+sCfgFile+" not found");
       return false;
     }
       catch (IOException e)
     {
       System.out.println("readFile open error : "+e);
       return false;
     }     
     // read the file
     log("readFile : try to read from : "+sCfgFile ) ;
     try
     {
       search = "<Panel" ;
       while((line=fileIn.readLine())!= null)
       {
         if( line.startsWith(search)){ log(line.substring(6,8)) ;lig = Integer.parseInt(line.substring(6,8)) -1 ;}
         else if( line.equalsIgnoreCase("</Panel>")){  lig++ ; col=0 ;}
         else
         {
           tabLines[lig][col] = new String(line) ;
           col++ ;
         }
       }

     }catch (Exception e)
     {
       System.out.println("readFile reading error:"+e);
     }
     try
     {
       fileIn.close();
     } catch (Exception e)
     {
       System.out.println("readFile closing error:"+e);
     }

     return true ;
   }
  
  /**************************************
   *  Write a particular panel to file  *
   *************************************/
  private void writeFile( int iNumPanel )
  {
      PrintWriter fileOut=null;
      String line="" ;
      int col=0, index=0 ;
      // write the current panel in the table
      for ( int i = 0; i < iMaxLines; i++ )
         {
           for ( int j=0; j < iMaxCols; j++) 
           { 
                line  = ""+i+","+j ;
                line += ","+vBricks[i][j].x ;
                line += ","+vBricks[i][j].y ;
                line += ","+vBricks[i][j].w ;
                line += ","+vBricks[i][j].h ;
                line += ","+vBricks[i][j].iHits ;
                line += ","+vBricks[i][j].color.getRed() + "," + vBricks[i][j].color.getGreen() + "," +  vBricks[i][j].color.getBlue();
                line += ","+vBricks[i][j].iType ;
                tabLines[iNumPanel-1][index] = line ;
                index++;
              }    
      }     
            
      // open the file
      log("writeFile : try to open : "+sCfgFile ) ;
      try
      {
        fileOut = new PrintWriter(new FileWriter(sCfgFile));
      } catch (Exception e)
      {
        System.out.println("writeFile opening error:"+e); 
      }
      // write the file
      try
      {
        log("writeFile : try to write to : "+sCfgFile ) ;
        for( int level = 0; level<99 ; level++ )
        {
          index=0;
          if(tabLines[level][0] != null)
          {
            if(level<10)
              fileOut.println("<Panel0"+(level+1)+">") ;
            else
              fileOut.println("<Panel"+(level+1)+">") ;
            for ( int i = 0; i < iMaxLines; i++ )
            {
              for ( int j=0; j < iMaxCols; j++) 
              { 
                fileOut.println(tabLines[level][index]) ;
                index++;
              }    
            }            
            fileOut.println("</Panel>") ;
          }
        }
      } catch (Exception e)
      {
        System.out.println("writeFile writing error:"+e); 
      }
     try
     {
       fileOut.close();
     } catch (Exception e)
     {
       System.out.println("writeFile closing error:"+e);
     }      
  }
  
  /**************************
   *  Build the tool panel  *
   *************************/  
   private void BuildToolPanel()
   {
     brickT br;
     Border border = BorderFactory.createBevelBorder(BevelBorder.RAISED, new Color(255,255,255),new Color(0,0,240)) ;
     // one hit
     br = new  brickT(10,10,80,20,1,Color.GREEN,1);        
     br.setBorder(border) ;
     br.setText("1 hit") ;
     br.setName("1hit");
     br.setActionCommand("1hit");
     br.addActionListener(this);
     toolPanel.add(br) ;
     br.requestFocus();
     // two hits
     br = new  brickT(10,40,80,20,2,Color.CYAN,2);        
     br.setBorder(border) ;
     br.setText("2 hits") ;
     br.setActionCommand("2hit");
     br.setName("2hit");
     br.addActionListener(this);     
     toolPanel.add(br) ;     
     // three hits
     br = new  brickT(10,70,80,20,1,Color.RED,3);        
     br.setBorder(border) ;
     br.setText("3 hits") ;
     br.setActionCommand("3hit");
     br.setName("3hit");
     br.addActionListener(this);     
     toolPanel.add(br) ;
     // invisible
     br = new  brickT(10,100,80,20,1,toolPanel.getBackground(),8);        
     //br.setBorder(border) ;
     br.setText("Invisible") ;
     br.setActionCommand("invisible");
     br.setName("invisible");
     br.addActionListener(this);     
     toolPanel.add(br) ;     
     // unbreakable
     br = new  brickT(10,130,80,20,0,new Color(153,102,51),9);        
     br.setBorder(border) ;
     br.setText("Unbreakable") ;
     br.setActionCommand("unbreakable");
     br.setName("unbreakable");
     br.addActionListener(this);     
     toolPanel.add(br) ;  
     // slow down
     br = new  brickT(10,160,80,20,1,Color.YELLOW,7);        
     br.setBorder(border) ;
     br.setText("Slow Down") ;
     br.setName("slow");
     br.setActionCommand("slow");
     br.addActionListener(this);     
     toolPanel.add(br) ;     
     // random
     br = new  brickT(10,190,80,20,1,Color.MAGENTA,6);        
     br.setBorder(border) ;
     br.setText("Random") ;
     br.setName("random");
     br.setActionCommand("random");
     br.addActionListener(this);     
     toolPanel.add(br) ;     
     // erase
     br = new  brickT(10,220,80,20,0,Color.WHITE,0);        
     br.setBorder(border) ;
     br.setText("Erase") ;
     br.setName("erase");
     br.setActionCommand("erase");
     br.addActionListener(this);     
     toolPanel.add(br) ;
     // level
     JLabel lab = new JLabel("Panel");
     lab.setBounds(10,260,30,16);
     toolPanel.add(lab) ;
     levelSpinner.setBounds(44,260,40,20);
     levelSpinner.setBackground(Color.WHITE);
     levelSpinner.setValue(new Integer(iCurrentLevel));
     levelSpinner.addChangeListener(this);
     toolPanel.add(levelSpinner);
     log("Level : "+levelSpinner.getValue().toString());

     // test
      buttonTest.setBounds(10,300,80,20);
      buttonTest.setBorder(border) ;
      buttonTest.setText("Test") ;
      buttonTest.setName("test") ;
      buttonTest.setActionCommand("test");
      buttonTest.addActionListener(this);     
      toolPanel.add(buttonTest) ;
      
     statusBar.setText("Brick type="+selectTool) ;      
   }
  
  /*******************************
   *   Toolpanel Button actions  *
   ******************************/
  public void actionPerformed(ActionEvent e) {
          JButton b = (JButton)e.getSource();
          log("Button pressed : "+b.getName());

         if (e.getActionCommand().equals("test")) {
           log("bTest="+bTest);
           if(!bTest) b.setText("Stop test");
           else b.setText("Test");
           bTest = !bTest ;
           barr.setVisible(bTest);
           ball.setVisible(bTest);
           if(bTest) ball.requestFocus();
         }
         else if (e.getActionCommand().startsWith("brick-")) {
           String sName = e.getActionCommand() ;
           sBrick=sName.substring(6);
           statusBar.setText("Brick type="+selectTool+"  brick#="+sBrick) ;
           drawBrick() ;
         }
         else
         {
           selectTool=e.getActionCommand();
           statusBar.setText("Brick type="+selectTool+"  brick#="+sBrick) ;
         }
    }
 
 public void stateChanged(ChangeEvent e) {
        SpinnerModel levelModel = levelSpinner.getModel();
        if (levelModel instanceof SpinnerNumberModel) {
            iCurrentLevel = Integer.parseInt(levelSpinner.getValue().toString()) ;
            log("level="+iCurrentLevel);
            this.setTitle("WallBrick Builder  [level "+iCurrentLevel+"]");
            // load and display the selected level
            if(readFile(iCurrentLevel)) vBricks[0][0].requestFocus();
            else BuildWall();
        }
}

    
 /*****************************
  *  Draw a particular brick  *
  ****************************/
 private void drawBrick()
 {
   brick br;
   int pos=0 ;  
   int typ=0, hits=0 ;
   Color color=null ;
   pos = sBrick.indexOf(",") ;
   iCurLig=Integer.parseInt(sBrick.substring(0,pos));
   iCurCol=Integer.parseInt(sBrick.substring(pos+1));
   log("sBrick="+sBrick+"  lig="+iCurLig+"  col="+iCurCol);   
   if(selectTool.equalsIgnoreCase("1hit"))
   {
     color = Color.GREEN ;
     typ=1 ; hits=1 ;
   }
   else if(selectTool.equalsIgnoreCase("2hit"))
   {
     color = Color.CYAN ;
     typ=2 ; hits=2 ;
   }   
   else if(selectTool.equalsIgnoreCase("3hit"))
   {
     color = Color.RED ;
     typ=3 ; hits=3 ;
   }
   else if(selectTool.equalsIgnoreCase("unbreakable"))
   {
     color = new Color(153,102,51) ;
     typ=9 ; hits=99 ;
   }
   else if(selectTool.equalsIgnoreCase("slow"))
   {
     color = Color.YELLOW ;
     typ=7 ; hits = 1 ;
   }   
   else if(selectTool.equalsIgnoreCase("random"))
   {
     color = Color.MAGENTA ;
     typ=6 ; hits = 1 ;
   }      
   else if(selectTool.equalsIgnoreCase("invisible"))
   {
     color = toolPanel.getBackground() ;
     typ=8 ; hits = 1 ;
   }
   else if(selectTool.equalsIgnoreCase("erase"))
   {
     color = Color.WHITE ;
     typ=0 ; hits=0 ;
   }
   vBricks[iCurLig][iCurCol].color = color ;
   vBricks[iCurLig][iCurCol].iType = typ ;
   vBricks[iCurLig][iCurCol].iHits = hits ;
   vBricks[iCurLig][iCurCol].setBackground(color);
   if(hits>0) vBricks[iCurLig][iCurCol].setText( ""+hits ) ;
   else       vBricks[iCurLig][iCurCol].setText("") ;
 
 }
 
  /*******************************
   *  Ouput messages on console  *
   ******************************/
  private void log( String msg)
  {
     if( bLog ) System.out.println(msg) ;
  }
  
   /************************
    *  Transparent cursor  *
    ***********************/
   public static final Cursor NO_CURSOR;
   static
   {
      Cursor c ;
      Toolkit t = Toolkit.getDefaultToolkit();
      Dimension d = t.getBestCursorSize(1,1);
      if(d.width!=0 && d.height!=0)
      {
         NO_CURSOR = t.createCustomCursor(new BufferedImage(d.width,d.height,BufferedImage.TYPE_INT_ARGB),new Point(0,0),"NO_CURSOR");
      }
      else
      {
         NO_CURSOR = null;
      }
   }
 
    /** Handle the key typed event  */
    public void keyTyped(KeyEvent e) {     
     }
   
   /** Handle the key pressed event */
   public void keyPressed(KeyEvent e) {
     int hits=0 ;
     int iKey = e.getKeyCode() ;
     log(""+iKey);
     if(iKey == 107 && vBricks[iCurLig][iCurCol].iType > 0 && vBricks[iCurLig][iCurCol].iType < 9)
     {
       // Increase hits
        if(vBricks[iCurLig][iCurCol].iHits < 5) 
        {       
          vBricks[iCurLig][iCurCol].iHits++;
          vBricks[iCurLig][iCurCol].setText(""+vBricks[iCurLig][iCurCol].iHits);       
        }
     }
     else if(iKey == 109 && vBricks[iCurLig][iCurCol].iType > 0 && vBricks[iCurLig][iCurCol].iType < 9)
        {
          // Decrease hits
          if(vBricks[iCurLig][iCurCol].iHits > 1) 
          {
            vBricks[iCurLig][iCurCol].iHits--;
            vBricks[iCurLig][iCurCol].setText(""+vBricks[iCurLig][iCurCol].iHits);       
          }
        } 
     else if(iKey == 37) // left
        {
          if(iCurCol>0) iCurCol-- ;
          vBricks[iCurLig][iCurCol].requestFocus();
        }        
     else if(iKey == 39) // right
        {
          if(iCurCol<14) iCurCol++ ;
          vBricks[iCurLig][iCurCol].requestFocus();
        }        
     else if(iKey == 38) // up
        {
          if(iCurLig>0) iCurLig-- ;
          vBricks[iCurLig][iCurCol].requestFocus();
        }        
     else if(iKey == 40) // down
        {
          if(iCurLig<14) iCurLig++ ;
          vBricks[iCurLig][iCurCol].requestFocus();
        }         
   }

   /** Handle the key released event  */
    public void keyReleased(KeyEvent e) {
   } 
 

 private int myRandomInteger(int min, int max) 
 { 
    return (int) (min + Math.random() * (max - min + 1)); 
 } 

/*
	public void paint(Graphics g) {
		log("paint()");
    //super.paint(g);
    //toolPanel.repaint();
    //panelCenter.repaint();
    Color c = g.getColor();
		//g.setColor(Color.RED);
		//g.fillRect(10,10,80,80);
		g.setColor(Color.BLUE);
		g.fillOval(posX-20,posY-20,10,10);
		//g.setColor(c);
	}
*/  
/*
 public void paintComponent(Graphics g) 
 { 
    //super.paintComponent(g); 
    log("paintComponent");
    Color c = g.getColor();
		g.setColor(Color.BLUE);
		g.fillOval(posX-20,posY-20,10,10);
 } 
 */
  public static void main(String[] args)
  {
    try
    {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }

    new Build();
  }
}