package oracle.forms.fd;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.net.URL;
import java.util.StringTokenizer;
import javax.swing.*;
import javax.swing.border.BevelBorder;
import oracle.forms.ui.VBean;
import oracle.forms.handler.IHandler;
import oracle.forms.properties.ID;

  /**
   * A Bean to play a brickwall game with Oracle Forms
   *
   * @author Francois Degrelle
   * @version 1.0
   */
   
public class FJBrick extends VBean implements MouseListener, 
                                              MouseMotionListener, 
                                              KeyListener, 
                                              Runnable{
	// the properties you can set
  public final static ID START    = ID.registerProperty("START");  
	public final static ID SETLOG   = ID.registerProperty("SETLOG");    
  // variables
  private int iPanelWidth=790, iPanelHeight=480 ;
  private int oldx=0, oldy=0, oldBarrX=-1;
  private int x=0, y=0, w=0, h=0, iSens = -1 ;
  private int iNbLines=10, iNbCols= 15, iMaxCols=15, iMaxLines=15 ;
  private int iRaqSize = 60 ;
  private int iTotBricks=0,iSeconds=0, iOldSeconds=0 ; 
  private int iCurrentLevel = 1, iNBLevels = 0 ;
  private int iSpeed = 10 ;
  private int iLifes = 3 ;
  private int iGridX=0, iGridY=0 ;
  private boolean bStart = false, bLog = false, bLoaded = false ;
  private int posX=50, posY=50, incX=-1, incY=-5, valincX=0 ;
  private JButton barr = new JButton();
  private JButton ball = new JButton();  
  private ActionMap actionMap1 = new ActionMap();
  private JLabel statusBar = new JLabel();
  private Color raqColor = new Color(0,0,204);
  private Color balColor = new Color(255,255,0);
  private Color bgColor  = new Color(240,255,240);  
  private  brickT[][] vBricks  = new brickT[iMaxLines][iMaxCols] ;  
  private String  sDir = System.getProperty("user.dir")+"/", sCfgFile = "brickwall.cfg" ;
  private String sStatus="", oldMsg="" ;
  private Rectangle barrRect = new Rectangle();
  private Point ptBall ;
  private int delay = 1000, seconds=0 ;
  private JPanel panel = new JPanel();
  private JFrame frame ;
  private Timer timer ;
  private BorderLayout layoutMain = new BorderLayout();
  private JPanel panelCenter = new JPanel();
  private IHandler  m_handler;  
  static  Thread runner ;
  private Graphics g2 = null ;
  private Graphics2D g3 = null ;
  private Color cBarr = new Color(0,0,200), cBall = new Color(0,0,255) ;
  private Dimension panelSize, screenSize, frameSize ;  
  private ImageIcon icBarr = new ImageIcon();
  private ImageIcon[] tbBricks = new ImageIcon[10] ;
  
  public FJBrick()
  {
    super();
    frame = new JFrame("Forms JavaBean - Break the wall");
    statusBar.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED)) ;
    frame.getContentPane().setLayout(layoutMain);
    panelCenter.setLayout(null);
    panelCenter.setSize(iPanelWidth,iPanelHeight);
    panelCenter.setBackground(bgColor);
    panelCenter.addMouseMotionListener(this);
    panelCenter.addMouseListener(this);
    panelCenter.add(barr);
    panelCenter.add(ball);    
    panelSize = panelCenter.getSize();    
    panelCenter.setCursor(NO_CURSOR);
    
    frame.getContentPane().add(statusBar, BorderLayout.SOUTH);
    DisplayStatus("Click the mouse to lauch the ball        (Esc) to iconize the window  (q) to quit");    
    frame.setBounds(10,10,790,510);
    frame.setBackground(new Color(255,255,255));
    frame.getContentPane().add(panelCenter, BorderLayout.CENTER);

    frame.addKeyListener(this);

    ActionListener taskPerformer = new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
          iSeconds++ ;
      }
    };
    timer = new Timer(delay, taskPerformer);
    loadIcons();
    // barr
    barr.setIcon(icBarr);
    barr.setBounds(1,1,iRaqSize,12);    
    barr.setLocation(x,y);
    // ball
    ball.setBounds(1,1,10,10);
    ball.setLocation(x+(iRaqSize/2), y-11);
    ball.setBackground(balColor);
    ball.setBorder(BorderFactory.createLineBorder(new Color(255,95,17))) ;
  }
  
    public void init(IHandler handler)
    {
      m_handler = handler;
      super.init(handler);
    }   
  
  /*********************
   *   ball movement   *
   ********************/
  void move()
  {
     int iPos=0 ;
     int iValue = 0, iVSens = 0, iHSens  = 0 ;
     int iOldX=0, iOldY=0 ;
     int inc=3;
     Rectangle bLeft, bRight ;
     Point pt ;
     boolean bClean=false ;
     incY = -inc ;
     while(true)
     {
      if( bStart )
      {
      
      if( posY < 10 )
       {
          iSens *= -1 ;
          incY =  inc * iSens ; // down
       }

      else if( posY > (y-5) )
       {
          if((posX+inc < barr.getX()) || (posX-inc > barr.getX()+60))
          {
            // -----------------
            // lost the ball !!!
            // -----------------
            log("lost the ball ! sart="+bStart);
            bStart = false ;
            timer.stop();
            x = iPanelWidth/2 ;
            y = iPanelHeight-40 ;
            posX = barr.getX()+(iRaqSize/2) ;
            posY = y-11 ;
            incX = 0 ;
            valincX = 0 ;            
            iLifes-- ;
            iSeconds = 0 ;
            iOldSeconds = 0 ;     
            posX = x+(iRaqSize/2) ;
            ptBall = new Point(posX, posY) ;             
            ball.setLocation(x+(iRaqSize/2), y-11);
            barr.setLocation(x,y);            
            DisplayStatus("");
            if(iLifes==0) { iLifes = 3; iCurrentLevel = 1 ; initGame(); }
          }
          else
          {
            //  -----------
            //  barr rebond
            //  -----------
            iSens *= -1 ;
            iPos = posX - barr.getX() ;
            if( iPos <= 5 ) valincX = -4 ;
            else if( iPos >=  6 && iPos <= 11 ) valincX = -3 ;
            else if( iPos >= 12 && iPos <= 19 ) valincX = -2 ;
            else if( iPos >= 20 && iPos <= 27 ) valincX = -1 ;
            else if( iPos >= 28 && iPos <= 31 ) valincX = 0 ;
            else if( iPos >= 32 && iPos <= 39 ) valincX = 1 ;
            else if( iPos >= 40 && iPos <= 47 ) valincX = 2 ;
            else if( iPos >= 48 && iPos <= 53 ) valincX = 3 ;
            else if( iPos >= 54 ) valincX = 4 ;

            incY =  inc * iSens ;
            posY += 2*incY ;
          }
       }
       //  ------------
       //  wall rebond
       //  ------------
       if( posX < 1 || posX+10 > iPanelWidth )
        {
          valincX *= -1 ;
          incX = valincX ;
          if( posX < 1 ) posX = 10 ;
          else posX = iPanelWidth-10 ;
          log("posX="+posX+"  incX="+incX);          
        }
       else incX = valincX ; 
       posX += incX ;
       if( posX != iOldX ) iOldX = posX ;
       if(bStart) posY += incY ;
       
       //  --------------------------
       //  is there a brick hitted ?
       //  --------------------------
       iGridX = posX / 52 ;
       iGridY = posY / 20 ;
       // if we are inside the brick matrix
       if( (iGridY >= 0 && iGridX >= 0) && (iGridY < iMaxLines && iGridX < iMaxCols))
       {
          // left border
          bLeft = new Rectangle(vBricks[iGridY][iGridX].x-2,vBricks[iGridY][iGridX].y,4,vBricks[iGridY][iGridX].h) ;
          if( (iGridX > 0) && vBricks[iGridY][iGridX-1].iType > 0 )
             bLeft = new Rectangle(0,0,0,0);
          
          // right border
          bRight  = new Rectangle(vBricks[iGridY][iGridX].x+vBricks[iGridY][iGridX].w-2,vBricks[iGridY][iGridX].y,4,vBricks[iGridY][iGridX].h) ;          
          if( (iGridX < iMaxCols-1) && vBricks[iGridY][iGridX+1].iType > 0 )
             bRight = new Rectangle(0,0,0,0);

          pt = new Point(posX, posY) ;
          // type 0 : brick is null   type 9 : brick is unbrokable
          if ( (vBricks[iGridY][iGridX].iType > 0 && vBricks[iGridY][iGridX].iType < 9) )
               //&& (iGridX != iOldX && iGridY != iOldY ) )
          {
            if(vBricks[iGridY][iGridX].iHits > 1)
            {                 
              // decrease compter
              vBricks[iGridY][iGridX].iHits-- ;
            }
            else 
            {
              // hide the brick
              vBricks[iGridY][iGridX].setVisible(false);
              bClean=true ;
              iTotBricks-- ;
              DisplayStatus(""+iTotBricks+" bricks to hit       (Esc) to iconize the window  (q) to quit");
            }
            if( iTotBricks == 0 )
            {
              // level finished
              bStart = false ;
              timer.stop();
              posX = barr.getX()+(iRaqSize/2) ;
              posY = y-20 ;
              incX = 0 ;
              valincX = 0 ;            
              
              // next level
              if(iCurrentLevel<99)
              {
                iCurrentLevel++ ;
                iNBLevels++ ;
                if( iNBLevels % 2 == 0 ) iLifes++ ;
                log("Try to load level : "+iCurrentLevel);
                while(!readFile(iCurrentLevel))
                {
                  iCurrentLevel++ ;
                  log("Try to load level : "+iCurrentLevel);
                  if(iCurrentLevel > 99)
                  {
                    JOptionPane.showMessageDialog(null, new AboutBox(), "About", JOptionPane.PLAIN_MESSAGE);
                    bStart = false ;
                    timer.stop();
                    runner.stop();                    
                    frame.setVisible(false) ;
                  }
                }
                initGame();
                DisplayStatus("");
              }
            }
            // glue brick
            if(vBricks[iGridY][iGridX].iType == 7) iSpeed *= 2.5 ;
            
          }
          // change the direction
          if(vBricks[iGridY][iGridX].iType == 6)
          { // random brick
            iValue = myRandomInteger(0,5);
            iVSens = myRandomInteger(0,1);
            iHSens = myRandomInteger(0,1);
            if(iHSens == 0) valincX = iValue * -1 ;
            else            valincX = iValue ;
            if(iVSens == 0) iSens *= -1 ;
            incY =  inc * iSens ;
          }
         // is it a border ?
          else if (vBricks[iGridY][iGridX].iType > 0)
          {
             if( (bLeft.contains(pt) || bRight.contains(pt)) && (incX != 0) )  
               {
                  // up ?
                  if( iSens < 0)
                  {
                    // left side
                    if(bLeft.contains(pt) && incX > 0)
                    {
                      // nothing on the up/left ?
                      if( (iGridX > 0) && 
                        ( (iGridY > 0) && (vBricks[iGridY-1][iGridX-1].iType == 0)) && 
                        ( (iGridY > 0) && (vBricks[iGridY][iGridX-1].iType == 0)) )                        
                      {
                         valincX *= -1 ;
                         incX = valincX ;    
                      }
                      else // inverse the direction
                      {
                         valincX *= -1 ;
                         incX = valincX ;
                         iSens *= -1 ;
                         incY =  inc * iSens ;
                      }                    
                    }
                    // right side
                    else if(bRight.contains(pt ) && incX < 0)
                    {
                      // nothing on the right ?
                      if( (iGridX < iMaxCols-1) && 
                        (((iGridY > 0) && (vBricks[iGridY-1][iGridX+1].iType == 0)) )&&
                        (((iGridY > 0) && (vBricks[iGridY][iGridX+1].iType == 0)) ))                        
                      {
                         valincX *= -1 ;
                         incX = valincX ;    
                      }
                      else // inverse the direction
                      {
                         valincX *= -1 ;
                         incX = valincX ;
                         iSens *= -1 ;
                         incY =  inc * iSens ;
                      }                    
                    }
                  }  
                  else
                  {
                    // down
                    // left side
                    if(bLeft.contains(pt) && incX > 0)
                    {
                      // nothing on the down/left ?
                      if( (iGridX > 0) && 
                        (((iGridY < iMaxLines) && (vBricks[iGridY+1][iGridX-1].iType == 0)) ) &&
                        (((iGridY < iMaxLines) && (vBricks[iGridY][iGridX-1].iType == 0)) ))                        
                      {
                         valincX *= -1 ;
                         incX = valincX ;    
                      }
                      else // inverse the direction
                      {
                         valincX *= -1 ;
                         incX = valincX ;
                         iSens *= -1 ;
                         incY =  inc * iSens ;
                      }                    
                    }
                    // right side
                    else if(bRight.contains(pt) && incX < 0)
                    {
                      // nothing on the right ?
                      if( (iGridX < iMaxCols-1) && 
                        (((iGridY < iMaxLines) && (vBricks[iGridY+1][iGridX+1].iType == 0)) ) &&
                        (((iGridY < iMaxLines) && (vBricks[iGridY][iGridX+1].iType == 0)) ))                        
                      {
                         valincX *= -1 ;
                         incX = valincX ;    
                      }
                      else // inverse the direction
                      {
                         valincX *= -1 ;
                         incX = valincX ;
                         iSens *= -1 ;
                         incY =  inc * iSens ;
                      }                    
                    }
                  }
               }
             else // inverse the direction
               {
                  iSens *= -1 ;
                  incY =  inc * iSens ;
               }
          }
       }
       // new ball position
       ball.setLocation( posX-5, posY-5 ) ;
       panelCenter.repaint(posX-30,posY-30,60,60);       
       if( bClean )
       {
         vBricks[iGridY][iGridX].iType = 0 ;
         bClean = false ;
       }
       
       try {
            Thread.sleep(iSpeed);
        } catch (InterruptedException e) {
        }
        // increase the speed each 60 seconds
        if((iSeconds > iOldSeconds) && (iSeconds % 60 == 0) && ((iSpeed / 1.2) > 1))
         {
           iOldSeconds = iSeconds ;
           iSpeed /=1.2 ; log("iSpeed="+iSpeed);
         }
      }
     }
  }

  /********************
   *  Start the game  *
   *******************/
  public boolean setProperty(ID property, Object value)
    {
      if (property == START)  // Start the game
      {
        if(!value.toString().equals("false"))
        {
          sDir = value.toString();
          log("new sDir="+sDir);
        }
        initGame();
        return true;
      }   
      else if (property == SETLOG)  // set the log on/off
      {
        if(value.toString().equalsIgnoreCase("TRUE")) bLog = true ;
        else bLog = false ;
        return true;
      }         
      else
      {
       return super.setProperty(property, value);
      }
    }
  
  /**********************
   *  Paint the screen  *
   *********************/
  public void paint(Graphics g) {
    super.paint(g);
    panelCenter.repaint();
	}
  
   /******************************
   *   read a particular panel   *
   ******************************/
  private boolean readFile( int iNumPanel )
   {
     BufferedReader fileIn=null;
     String line="", search="" ;
     int lig=0,col=0,x=0,y=0,w=0,h=0,r=0,g=0,b=0 ;
     int color=0, hits=0, type=0 ;
     boolean bCont=true, bFound=false, bOk=false ;
     brickT brk ;
     StringTokenizer st ;
     iTotBricks = 0 ;
     iSeconds = 0 ;
     clearTab();
     // Open the file
     log("readFile : try to open : "+sDir+sCfgFile ) ;
     try
     {
       fileIn = new BufferedReader( new FileReader(sDir+sCfgFile));
     } catch (FileNotFoundException e)
     {
       System.out.println("readFile open error : "+sDir+sCfgFile+" not found");
       return false;
     }
       catch (IOException e)
     {
       System.out.println("readFile open error : "+e);
       return false;
     }     
     // read the file
     log("readFile : try to read from : "+sCfgFile ) ;
     DisplayStatus("Loading level "+iNumPanel);
     try
     {
       if(iNumPanel < 10 ) search = "<Panel0"+iNumPanel+">" ;
       else search = "<Panel"+iNumPanel+">" ;
       log("Search for panel : "+search);
       while((line=fileIn.readLine())!= null && bCont)
       {
         //log(line);
         if( line.equalsIgnoreCase("</Panel>") && bFound){  bFound= false; bCont = false ; }
         if( bFound )
         {
           st = new StringTokenizer(line,",");
           lig = Integer.parseInt(st.nextToken()) ;
           col = Integer.parseInt(st.nextToken()) ;
           x = Integer.parseInt(st.nextToken()) ;
           y = Integer.parseInt(st.nextToken()) ;
           w = Integer.parseInt(st.nextToken()) ;
           h = Integer.parseInt(st.nextToken()) ;
           hits = Integer.parseInt(st.nextToken()) ;
           r = Integer.parseInt(st.nextToken()) ;
           g = Integer.parseInt(st.nextToken()) ;
           b = Integer.parseInt(st.nextToken()) ;
           type = Integer.parseInt(st.nextToken()) ;
           if(type==8)
             {
               brk = new  brickT(x,y,w,h,hits,bgColor,type);
               brk.setBorder(null);
             }
           else
             {
               brk = new  brickT(x,y,w,h,hits,new Color(r,g,b),type);
             }
           if(type !=0 && type != 8) brk.setIcon(tbBricks[type]);
           vBricks[lig][col] = brk ;  
           if(type>0)
           {
             panelCenter.remove(vBricks[lig][col]);
             panelCenter.add(brk);           
           }

           if(type > 0 && type < 9) iTotBricks++ ;
         }
         if( line.equalsIgnoreCase(search)) 
         {
           log("level found");
           bFound= true ;         
           bOk = true ;
         }
       }
      log("level : "+iNumPanel+" loaded   bOk="+bOk);
      DisplayStatus("Click the mouse to launch the ball       (Esc) to iconize the window  (q) to quit");       
     }catch (Exception e)
     {
       System.out.println("readFile reading error:"+e);
       return false ;
     }
     try
     {
       fileIn.close();
     } catch (Exception e)
     {
       System.out.println("readFile closing error:"+e);
       return false ;
     }
     
     bLoaded = bOk ;
     return bOk ;
   }

  /*******************************
   *  Clear the table of bricks  *
   ******************************/
  private void clearTab()
  {
    int i,j;
    
    for (i=0 ; i<iMaxLines; i++)
    {
      for (j=0 ; j<iMaxCols; j++)
      {
        if(vBricks[i][j] != null) panelCenter.remove(vBricks[i][j]);
        vBricks[i][j] = new brickT() ;
      }
    }
    iTotBricks = 0 ;
  }
  
     /*****************
     *   barr move   *
     ****************/
     public void mouseMoved(MouseEvent e) {
       // draw the new barr position
        barr.setLocation((e.getX()< panelSize.width-iRaqSize ? e.getX() : panelSize.width-iRaqSize), y);
        if(! bStart) {
           posX = barr.getX()+(iRaqSize/2)-(ball.getWidth()/2) ;
           if(posY == y-11) ball.setLocation(posX, y-11);
        }       
    }

    public void mouseDragged(MouseEvent e) {
    }

   public void mousePressed(MouseEvent e) {
    }

    public void mouseReleased(MouseEvent e) {
    }

    public void mouseEntered(MouseEvent e) {
    }

    public void mouseExited(MouseEvent e) {
    }

    public void mouseClicked(MouseEvent e) {
       bStart = ! bStart ;
       if(bStart) 
       {
         log("Start=true" ) ;
         DisplayStatus(""+iTotBricks+" bricks to hit       (Escape) to iconize the window  (q) to quit");
         iSeconds = 0 ;
         iOldSeconds = 0 ; 
         timer.start(); 
         startMove();
       }
       else 
       {
         log("Start=false" ) ;
         timer.stop(); 
       }
    }

    /** Handle the key typed event from the text field. */
    public void keyTyped(KeyEvent e) {
          ;
        }
   /** Handle the key pressed event */
   public void keyPressed(KeyEvent e) {
     int iKey = (int)(e.getKeyChar()) ;
     System.out.println("keyPressed:"+iKey) ;
     if(iKey == e.VK_ESCAPE)
     {
       // Hide the window
       bStart = false ;
       timer.stop();
       frame.setState(Frame.ICONIFIED);
     }     
     if(e.getKeyChar() == 'q')
     {
       // Hide the window
       bStart = false ;
       timer.stop();
       runner.stop();
       frame.setVisible(false);
     }          
   }

   /** Handle the key released event from the text field. */
   public void keyReleased(KeyEvent e) {
   }


   /************************
    *  Transparent cursor  *
    ***********************/
   public static final Cursor NO_CURSOR;
   static
   {
      Toolkit t = Toolkit.getDefaultToolkit();
      Dimension d = t.getBestCursorSize(1,1);
      if(d.width!=0 && d.height!=0)
      {
         NO_CURSOR = t.createCustomCursor(new BufferedImage(d.width,d.height,BufferedImage.TYPE_INT_ARGB),new Point(0,0),"NO_CURSOR");
      }
      else
      {
         NO_CURSOR = null;
      }
   }
   
  /*******************************
   *   Init the game parameters  *
   ******************************/
  private void initGame()
  {
    iSpeed = 10 ;
    iSeconds = 0 ;
    iOldSeconds = 0 ;     
    if(!readFile(iCurrentLevel))
      {
        System.out.println("Error reading level");
        JOptionPane.showMessageDialog(null, "Unable to open the "+sDir+sCfgFile+" configuration file", "Error", JOptionPane.ERROR_MESSAGE);
        frame.setVisible(false);
      }
    frame.setTitle("Forms JavaBean Wall-Brick     [level "+iCurrentLevel+"]");    
    x = iPanelWidth/2 ;
    y = iPanelHeight-40 ;
    posY = y-11 ;
    // ball
    ball.setLocation(x+(iRaqSize/2), y-11);
    barr.setLocation(x,y);
    ptBall = new Point(posX, posY) ;    
    posX = barr.getX()+(iRaqSize/2) ;
    frame.setVisible(true);           
    repaint();
  }
 
  /************************
   *  Status bar message  *
   ***********************/
  private void DisplayStatus(String sMsg)
  {
    String msg="" ;
    if(sMsg.equalsIgnoreCase("Save")) oldMsg = msg ;
    else if(sMsg.equalsIgnoreCase("Restore")) msg = oldMsg ;
    else if(!sMsg.equals(""))
    {
      sStatus = sMsg ;
      msg = sMsg ;
    }
    else msg=sStatus ;
    statusBar.setText(msg + "             ["+iLifes+" lifes]");
  }
 
  
  /*******************************
   *  Ouput messages on console  *
   ******************************/
  private void log( String msg)
  {
     if( bLog ) System.out.println(msg) ;
  }
 
  private int myRandomInteger(int min, int max) 
  { 
    return (int) (min + Math.random() * (max - min + 1)); 
  }
  
  /***********************************************
   *  run the move() function in its own thread  *
   **********************************************/
   private void startMove()
    {
      if (runner == null )
      {
        runner = new Thread(this);
        runner.start();
      }
    }
 
  /***************************
   *  Load the bricks icons  *
   **************************/
   private void loadIcons()
   {
      icBarr = new ImageIcon(loadImage("/barr.jpg"));
      tbBricks[1] = new ImageIcon(loadImage("/bt_vert.jpg"));
      tbBricks[2] = new ImageIcon(loadImage("/bt_bleu.jpg"));
      tbBricks[3] = new ImageIcon(loadImage("/bt_rouge.jpg"));
      tbBricks[6] = new ImageIcon(loadImage("/bt_violet.jpg"));
      tbBricks[7] = new ImageIcon(loadImage("/bt_jaune.jpg"));
      tbBricks[8] = new ImageIcon(loadImage("/bt_invis.jpg"));
      tbBricks[9] = new ImageIcon(loadImage("/bt_ocre.jpg"));
   }
  
   /********************************************
   *  Load an image from the current JAR file  *
   ********************************************/
   private Image loadImage(String imageName)
   {
     URL imageURL = null;
     boolean loadSuccess = false;
     Image img = null ;

     imageURL = getClass().getResource(imageName);
     if (imageURL != null)
     {
       try
       {
         img = Toolkit.getDefaultToolkit().getImage(imageURL);
         loadSuccess = true;
       }
       catch (Exception ilex)
       {
         log("Error loading image from JAR: " + ilex.toString());
       }
     }
     else
     {
       log("Unable to find " + imageName + " in JAR");
     }
     return img ;
   }
   
 public void run()
 {
    move(); 
 }

  public static void main(String[] args)
  {
    try
    {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }

    new FJBrick();
  }
}