package oracle.forms.fd;

import java.awt.Dimension;
import java.awt.Font;
import java.awt.Toolkit;
import javax.swing.JPanel;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import javax.swing.border.Border;
import javax.swing.BorderFactory;
import javax.swing.JLabel;

public class HelpBox extends JPanel 
{
  private Border border = BorderFactory.createEtchedBorder();
  private GridBagLayout layoutMain = new GridBagLayout();
  private JLabel[] tabLabs = new JLabel[20] ;
  private Dimension ScreenDim = Toolkit.getDefaultToolkit().getScreenSize();
  private int iWidth=(int)ScreenDim.getWidth()/2, iHeight=(int)ScreenDim.getHeight()/2;

  public HelpBox()
  {
    try
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }

  }

  private void jbInit() throws Exception
  {
    int i = 0 ;
    this.setLayout(null);
    this.setBorder(border);
    this.setPreferredSize(new Dimension(500,400));
    tabLabs[i] = new JLabel("WallBrick Builder - quick help");
    tabLabs[i].setFont(new Font("Arial", Font.PLAIN, 12));
    tabLabs[i++] = new JLabel("     Actions");    
    tabLabs[i].setFont(new Font("Arial", Font.BOLD, 12));
    tabLabs[i++] = new JLabel("- Choose a brick model in the tool panel then click on the central panel to fix it");
    tabLabs[i++] = new JLabel("- Use the arrow keys to select a particular brick");
    tabLabs[i++] = new JLabel("- Type + or - on keybord to increase/decrease the number of hits need");    
    tabLabs[i++] = new JLabel("- Choose the [clear brick] in the tool panel and click the brick you want to erase");
    tabLabs[i++] = new JLabel("- Click the Erase level option menu to erase the whole level");
    tabLabs[i++] = new JLabel("- Click the Save current level to save on disk the current level");
    tabLabs[i++] = new JLabel("- Click the +/- buttons to change the current level");    
    tabLabs[i++] = new JLabel("     Bricks");    
    tabLabs[i++] = new JLabel("- [1 hit] is a standard 1 hit brick");
    tabLabs[i++] = new JLabel("- [2 hits] is a standard 2 hits brick");
    tabLabs[i++] = new JLabel("- [3 hits] is a standard 3 hits brick");
    tabLabs[i++] = new JLabel("- [Invisible]");
    tabLabs[i++] = new JLabel("- [Unbrokable] is a brick you cannot broke");
    tabLabs[i++] = new JLabel("- [Slow down] is a brick that slow down the ball when hitted");
    tabLabs[i++] = new JLabel("- [Random] is a special brick with a random direction rebond");    
    tabLabs[i++] = new JLabel("     Test mode");    
    tabLabs[i++] = new JLabel("- you can click the [test] button at anytime to test the current level");    
    for(int j=0 ; j<i; j++)
    {
      tabLabs[j].setSize(500,20);
      tabLabs[j].setLocation(10,j*20);
      this.add(tabLabs[j]);
    }
  }
}