package oracle.forms.fd;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.*;
import java.awt.image.BufferedImage;
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.net.URL;
import java.util.StringTokenizer;
import javax.swing.*;
import javax.swing.border.BevelBorder;
import oracle.forms.ui.VBean;
import oracle.forms.handler.IHandler;
import oracle.forms.properties.ID;

//public class FJBrick extends VBean implements MouseListener, MouseMotionListener, KeyListener, Runnable{
public class Jbrick extends JFrame implements MouseListener, MouseMotionListener, KeyListener, Runnable{
	public final static ID START      = ID.registerProperty("START");  
	public final static ID INIT       = ID.registerProperty("INIT");    
  private int iPanelWidth=790, iPanelHeight=480 ;
  private int oldx=0, oldy=0, oldBarrX=-1, barrPosX=0 ;
  private int x=0, y=0, w=0, h=0, iSens = -1 ;
  private int iNbLines=10, iNbCols= 15, iMaxCols=15, iMaxLines=15 ;
  private int iRaqSize = 60 ;
  private int iTotBricks=0,iSeconds=0, iOldSeconds=0 ; 
  private int iCurrentLevel = 1, iNBLevels = 0 ;
  private int iSpeed = 15 ;
  private int iLifes = 3 ;
  private int iGridX=0, iGridY=0 ;
  private boolean bStart = false, bLog = true, bLoaded = false ;
  private int posX=50, posY=50, incX=-1, incY=-5, valincX=0 ;
  private brick barr = new brick() ;
  private ActionMap actionMap1 = new ActionMap();
  private JLabel statusBar = new JLabel();
  private Color raqColor = new Color(0,0,204);
  private Color balColor = new Color(255,255,0);
  private Color bgColor  = new Color(240,255,240);  
  private  brick[][] vBricks  = new brick[iMaxLines][iMaxCols] ;  
  private String  sCfgFile = "brickwall.cfg" ;
  private String sStatus="" ;
  private Rectangle barrRect = new Rectangle();
  private Point ptBall ;
  private int delay = 1000, seconds=0 ;
  private JPanel panel = new JPanel();
  private JFrame frame ;
  private Timer timer ;
  private BorderLayout layoutMain = new BorderLayout();
  private JPanel panelCenter = new JPanel();
  private IHandler  m_handler;  
  static  Thread runner ;
  private Graphics g2 = null ;
  private Graphics2D g3 = null ;
  private Color cBarr = new Color(0,0,200), cBall = new Color(0,0,255) ;
  private Dimension panelSize, screenSize, frameSize ;  
  private ImageIcon icBarr = new ImageIcon("/barr.jpg");
  private ImageIcon[] tbBricks = new ImageIcon[10] ;
  
  public Jbrick()
  {
    super();
    frame = new JFrame("Build wall");
    //frame.setContentPane(this);
    statusBar.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED)) ;
    frame.getContentPane().setLayout(layoutMain);
    panelCenter.setLayout(null);
    panelCenter.setSize(iPanelWidth,iPanelHeight);
    panelCenter.setBackground(bgColor);
    panelCenter.addMouseMotionListener(this);
    panelCenter.addMouseListener(this);
    panelSize = panelCenter.getSize();    
    panelCenter.setCursor(NO_CURSOR);
    barrPosX = panelSize.width/2 - (iRaqSize/2) ;
    barr.x = barrPosX ;
    
    frame.getContentPane().add(statusBar, BorderLayout.SOUTH);
    DisplayStatus("Click the mouse to lauch the ball        (Esc) to iconize the window  (q) to quit");    
    frame.setBounds(10,10,790,500);
    frame.setBackground(new Color(255,255,255));
    frame.getContentPane().add(panelCenter, BorderLayout.CENTER);

    frame.addKeyListener(this);
    frame.setVisible(true);       

    ActionListener taskPerformer = new ActionListener() {
      public void actionPerformed(ActionEvent evt) {
          iSeconds++ ;
      }
    };
    timer = new Timer(delay, taskPerformer);
    loadIcons();
    initGame();
  }
  
   /*----------- 
    public void init(IHandler handler)
    {
      m_handler = handler;
      super.init(handler);
    }   
   ------------*/ 
  
  /*********************
   *   ball movement   *
   ********************/
  void move()
  {
     int iPos=0 ;
     int iValue = 0, iVSens = 0, iHSens  = 0 ;
     int iOldX=0, iOldY=0 ;
     Rectangle bLeft, bRight ;
     boolean bClean=false ;
     while(true)
     {
      if( bStart )
      {
      
      if( posY > y-10 ) drawBarr(barrPosX);
      
      if( posY < 5 )
       {
          iSens *= -1 ;
          incY =  5 * iSens ; // down
       }

      else if( posY > (y-5) )
       {
          if((posX+5 < barr.x) || (posX-5 > barr.x+60))
          {
            // -----------------
            // lost the ball !!!
            // -----------------
            log("lost the ball ! sart="+bStart);
            bStart = false ;
            timer.stop();
            posX = barr.x+(iRaqSize/2) ;
            posY = y-20 ;
            incX = 0 ;
            valincX = 0 ;            
            iLifes-- ;
            iSeconds = 0 ;
            iOldSeconds = 0 ;     
            posX = x+(iRaqSize/2) ;
            barrPosX = panelSize.width/2 - (iRaqSize/2) ;
            barr.x = barrPosX ;
            posY = y-20 ;
            barrRect = new Rectangle(barrPosX-4,y-30,70,30);
            ptBall = new Point(posX, posY) ;                
            DisplayStatus("");
            drawBarr(barrPosX);
            posX = barr.x+(iRaqSize/2) ;
            drawBall(true);
            if(iLifes==0) initGame();
          }
          else
          {
            //  -----------
            //  barr rebond
            //  -----------
            iSens *= -1 ;
            iPos = posX - barr.x ;
            if( iPos >= 0 && iPos <= 5 ) valincX = -4 ;
            else if( iPos >=  6 && iPos <= 11 ) valincX = -3 ;
            else if( iPos >= 12 && iPos <= 19 ) valincX = -2 ;
            else if( iPos >= 20 && iPos <= 27 ) valincX = -1 ;
            else if( iPos >= 28 && iPos <= 31 ) valincX = 0 ;
            else if( iPos >= 32 && iPos <= 39 ) valincX = 1 ;
            else if( iPos >= 40 && iPos <= 47 ) valincX = 2 ;
            else if( iPos >= 48 && iPos <= 53 ) valincX = 3 ;
            else if( iPos >= 54 ) valincX = 4 ;

            incY =  5 * iSens ;
            posY += 2*incY ;
          }
       }
       //  ------------
       //  wall rebond
       //  ------------
       if( posX < 1 || posX+10 > iPanelWidth )
        {
          valincX *= -1 ;
          incX = valincX ;
          if( posX < 1 ) posX = 10 ;
          else posX = iPanelWidth-10 ;
          log("posX="+posX+"  incX="+incX);          
        }
       else incX = valincX ; 
       posX += incX ;
       if( posX != iOldX ) iOldX = posX ;
       if(bStart) posY += incY ;
       
       //  --------------------------
       //  is there a brick hitted ?
       //  --------------------------
       iGridX = posX / 52 ;
       iGridY = posY / 20 ;
       // if we are inside the brick matrix
       if( (iGridY >= 0 && iGridX >= 0) && (iGridY < iMaxLines && iGridX < iMaxCols))
       {
          // left border
          bLeft = new Rectangle(vBricks[iGridY][iGridX].x-4,vBricks[iGridY][iGridX].y+2,8,vBricks[iGridY][iGridX].h-4) ;
          // right border
          bRight  = new Rectangle(vBricks[iGridY][iGridX].x+vBricks[iGridY][iGridX].w-4,vBricks[iGridY][iGridX].y+2,8,vBricks[iGridY][iGridX].h-4) ;

          if ( (vBricks[iGridY][iGridX].iType > 0 && vBricks[iGridY][iGridX].iType < 9) )
          {

            if(vBricks[iGridY][iGridX].iHits > 1)
            {                 
              // decrease compter
              vBricks[iGridY][iGridX].iHits-- ;
            }
            else 
            {
              // hide the brick
              hideBrick(iGridY,iGridX);
              bClean = true ;
              iTotBricks-- ;
              DisplayStatus(""+iTotBricks+" bricks to hit       (Esc) to iconize the window  (q) to quit");
            }
            if( iTotBricks == 0 )
            {
              // level finished
              bStart = false ;
              timer.stop();
              posX = barr.x+(iRaqSize/2) ;
              posY = y-20 ;
              incX = 0 ;
              valincX = 0 ;            
              
              // next level
              if(iCurrentLevel<99)
              {
                iCurrentLevel++ ;
                iNBLevels++ ;
                if( iNBLevels % 2 == 0 ) iLifes++ ;
                log("Try to load level : "+iCurrentLevel);
                while(!readFile(iCurrentLevel))
                {
                  iCurrentLevel++ ;
                  log("Try to load level : "+iCurrentLevel);
                  if(iCurrentLevel > 99)
                  {
                    JOptionPane.showMessageDialog(this, new AboutBox(), "About", JOptionPane.PLAIN_MESSAGE);
                    frame.setVisible(false) ;
                  }
                }
                initGame();
                DisplayStatus("");
              }
            }
            // glue brick
            if(vBricks[iGridY][iGridX].iType == 7) iSpeed *= 2.5 ;
          }
          // change the direction
          if(vBricks[iGridY][iGridX].iType == 6)
          { // random brick
            iValue = myRandomInteger(0,5);
            iVSens = myRandomInteger(0,1);
            iHSens = myRandomInteger(0,1);
            if(iHSens == 0) valincX = iValue * -1 ;
            else            valincX = iValue ;
            if(iVSens == 0) iSens *= -1 ;
            incY =  5 * iSens ;
          }
         // is it a border ?
          else if (vBricks[iGridY][iGridX].iType > 0)
          {
             if( (bLeft.contains(ptBall) || bRight.contains(ptBall)) && (incX != 0) )  
               {
                  // up ?
                  if( iSens < 0)
                  {
                    // left side
                    if(bLeft.contains(ptBall) && incX > 0)
                    {
                      // nothing on the up/left ?
                      if( (iGridX > 0) && 
                        (((iGridY > 0) && (vBricks[iGridY-1][iGridX-1].iType == 0)) || (iGridY == 0)) )
                      {
                         valincX *= -1 ;
                         incX = valincX ;    
                      }
                      else // inverse the direction
                      {
                         valincX *= -1 ;
                         incX = valincX ;
                         iSens *= -1 ;
                         incY =  5 * iSens ;
                      }                    
                    }
                    // right side
                    else if(bRight.contains(ptBall) && incX < 0)
                    {
                      // nothing on the right ?
                      if( (iGridX < iMaxCols) && 
                        (((iGridY > 0) && (vBricks[iGridY-1][iGridX+1].iType == 0)) || (iGridY == 0)) )
                      {
                         valincX *= -1 ;
                         incX = valincX ;    
                      }
                      else // inverse the direction
                      {
                         valincX *= -1 ;
                         incX = valincX ;
                         iSens *= -1 ;
                         incY =  5 * iSens ;
                      }                    
                    }
                  }  
                  else
                  {
                    // down
                    // left side
                    if(bLeft.contains(ptBall) && incX > 0)
                    {
                      // nothing on the down/left ?
                      if( (iGridX > 0) && 
                        (((iGridY < iMaxLines) && (vBricks[iGridY+1][iGridX-1].iType == 0)) || (iGridY >= iMaxLines)) )
                      {
                         valincX *= -1 ;
                         incX = valincX ;    
                      }
                      else // inverse the direction
                      {
                         valincX *= -1 ;
                         incX = valincX ;
                         iSens *= -1 ;
                         incY =  5 * iSens ;
                      }                    
                    }
                    // right side
                    else if(bRight.contains(ptBall) && incX < 0)
                    {
                      // nothing on the right ?
                      if( (iGridX < iMaxCols) && 
                        (((iGridY < iMaxLines) && (vBricks[iGridY+1][iGridX+1].iType == 0)) || (iGridY >= iMaxLines)) )
                      {
                         valincX *= -1 ;
                         incX = valincX ;    
                      }
                      else // inverse the direction
                      {
                         valincX *= -1 ;
                         incX = valincX ;
                         iSens *= -1 ;
                         incY =  5 * iSens ;
                      }                    
                    }
                  }
               }
             else // inverse the direction
               {
                  iSens *= -1 ;
                  incY =  5 * iSens ;
               }
          }
          if( (vBricks[iGridY][iGridX].iType > 0) && ! bClean ) drawBrick(iGridY,iGridX);   
       }
       // new ball position
       drawBall(false) ;
       if( bClean )
       {
         vBricks[iGridY][iGridX].iType = 0 ;
         bClean = false ;
       }
       
       try {
            Thread.sleep(iSpeed);
        } catch (InterruptedException e) {
        }
        // increase the speed each 60 seconds
        if((iSeconds > iOldSeconds) && (iSeconds % 60 == 0) && ((iSpeed / 1.5) > 1))
         {
           iOldSeconds = iSeconds ;
           iSpeed /=1.5 ; log("iSpeed="+iSpeed);
         }
      }
     }
  }
  /*-----
    public boolean setProperty(ID property, Object value)
    {
      if (property == START)  // set the text of the JTextField
      {
        addMouseMotionListener(this);
        addMouseListener(this);
        return true;
      }
      else if (property == INIT)  // set the text of the JTextField
      {
        move();
        return true;
      }      
      else
      {
       return super.setProperty(property, value);
      }
    }
  ---*/
  /**********************
   *  Paint the screen  *
   *********************/
	/**/
  public void paint(Graphics g) {
   int i=0,j=0 ;
    Graphics g2 = panelCenter.getGraphics() ;
    Color c = g2.getColor();
    if( bLoaded )
    {
      for ( i = 0; i < iMaxLines; i++ )
      {
        for ( j = 0; j < iMaxCols; j++) 
        { 
           if( vBricks[i][j].iType > 0 )
           {
             drawBrick(j,i);
           }
        }
      }
    }
		g2.setColor(c);
    drawBarr(barrPosX);
    drawBall(true);
	}
  /**/
	/**/
  private void re_paint() {
   int i=0,j=0 ;
    Graphics g2 = panelCenter.getGraphics() ;
    Color c = g2.getColor();
    if( bLoaded )
    {
      for ( i = 0; i < iMaxLines; i++ )
      {
        for ( j = 0; j < iMaxCols; j++) 
        { 
           if( vBricks[i][j].iType > 0 )
           {
             drawBrick(j,i);
           }
        }
      }
    }
		g2.setColor(c);
    drawBarr(barrPosX);
    drawBall(true);
	}
  /**/

   /******************************
   *   read a particular panel   *
   ******************************/
  private boolean readFile( int iNumPanel )
   {
     BufferedReader fileIn=null;
     String line="", search="" ;
     int lig=0,col=0,x=0,y=0,w=0,h=0,r=0,g=0,b=0 ;
     int color=0, hits=0, type=0 ;
     boolean bCont=true, bFound=false, bOk=false ;
     brick brk ;
     StringTokenizer st ;
     iTotBricks = 0 ;
     iSeconds = 0 ;
     clearTab();
     // Open the file
     log("readFile : try to open : "+sCfgFile ) ;
     try
     {
       fileIn = new BufferedReader( new FileReader(sCfgFile));
     } catch (FileNotFoundException e)
     {
       System.out.println("readFile open error : "+sCfgFile+" not found");
       return false;
     }
       catch (IOException e)
     {
       System.out.println("readFile open error : "+e);
       return false;
     }     
     // read the file
     log("readFile : try to read from : "+sCfgFile ) ;
     try
     {
       if(iNumPanel < 10 ) search = "<Panel0"+iNumPanel+">" ;
       else search = "<Panel"+iNumPanel+">" ;
       log("Search for panel : "+search);
       while((line=fileIn.readLine())!= null && bCont)
       {
         //log(line);
         if( line.equalsIgnoreCase("</Panel>") && bFound){  bFound= false; bCont = false ; }
         if( bFound )
         {
           st = new StringTokenizer(line,",");
           lig = Integer.parseInt(st.nextToken()) ;
           col = Integer.parseInt(st.nextToken()) ;
           x = Integer.parseInt(st.nextToken()) ;
           y = Integer.parseInt(st.nextToken()) ;
           w = Integer.parseInt(st.nextToken()) ;
           h = Integer.parseInt(st.nextToken()) ;
           hits = Integer.parseInt(st.nextToken()) ;
           r = Integer.parseInt(st.nextToken()) ;
           g = Integer.parseInt(st.nextToken()) ;
           b = Integer.parseInt(st.nextToken()) ;
           type = Integer.parseInt(st.nextToken()) ;
           if(type==8)
             {
               brk = new  brick(x,y,w,h,hits,bgColor,type);
             }
           else
             {
               brk = new  brick(x,y,w,h,hits,new Color(r,g,b),type);
             }
             vBricks[lig][col] = brk ;  

           if(type > 0 && type < 9) iTotBricks++ ;
         }
         if( line.equalsIgnoreCase(search)) 
         {
           log("level found");
           bFound= true ;         
           bOk = true ;
         }
       }
      log("level : "+iNumPanel+" loaded   bOk="+bOk);
      DisplayStatus("Click the mouse to launch the ball       (Esc) to iconize the window  (q) to quit");       
     }catch (Exception e)
     {
       System.out.println("readFile reading error:"+e);
       return false ;
     }
     try
     {
       fileIn.close();
     } catch (Exception e)
     {
       System.out.println("readFile closing error:"+e);
       return false ;
     }
     
     bLoaded = bOk ;
     return bOk ;
   }

  /*******************************
   *  Clear the table of bricks  *
   ******************************/
  private void clearTab()
  {
    int i,j;
    
    for (i=0 ; i<iMaxLines; i++)
    {
      for (j=0 ; j<iMaxCols; j++)
      {
        vBricks[i][j] = new brick() ;
      }
    }
    iTotBricks = 0 ;
    g2.setColor(bgColor);
    g2.fillRect(0,0,panelCenter.getWidth(),panelCenter.getHeight());
  }
  
     /*****************
     *   barr move   *
     ****************/
     public void mouseMoved(MouseEvent e) {
       // draw the new barr position
       barrPosX = e.getX();
       barrRect = new Rectangle(barrPosX-4,y-30,70,30);
       drawBarr(barrPosX);
       
       if(! bStart) {
          posX = barr.x+(iRaqSize/2) ;
          if(posY == y-20) drawBall(true) ;
       }
    }

    public void mouseDragged(MouseEvent e) {
    }

   public void mousePressed(MouseEvent e) {
    }

    public void mouseReleased(MouseEvent e) {
    }

    public void mouseEntered(MouseEvent e) {
    }

    public void mouseExited(MouseEvent e) {
    }

    public void mouseClicked(MouseEvent e) {
       bStart = ! bStart ;
       if(bStart) 
       {
         log("Start=true" ) ;
         DisplayStatus(""+iTotBricks+" bricks to hit       (Escape) to iconize the window  (q) to quit");
         iSeconds = 0 ;
         iOldSeconds = 0 ; 
         timer.start(); 
         startMove();
       }
       else 
       {
         log("Start=false" ) ;
         timer.stop(); 
       }
    }

    /** Handle the key typed event from the text field. */
    public void keyTyped(KeyEvent e) {
          ;
        }
   /** Handle the key pressed event */
   public void keyPressed(KeyEvent e) {
     int iKey = (int)(e.getKeyChar()) ;
     System.out.println("keyPressed:"+iKey) ;
     if(iKey == e.VK_ESCAPE)
     {
       // Hide the window
       bStart = false ;
       timer.stop();
       frame.setState(Frame.ICONIFIED);
     }     
     if(e.getKeyChar() == 'q')
     {
       // Hide the window
       bStart = false ;
       timer.stop();
       runner.stop();
       frame.setVisible(false);
     }          
   }

   /** Handle the key released event from the text field. */
   public void keyReleased(KeyEvent e) {
   }


   /************************
    *  Transparent cursor  *
    ***********************/
   public static final Cursor NO_CURSOR;
   static
   {
      Toolkit t = Toolkit.getDefaultToolkit();
      Dimension d = t.getBestCursorSize(1,1);
      if(d.width!=0 && d.height!=0)
      {
         NO_CURSOR = t.createCustomCursor(new BufferedImage(d.width,d.height,BufferedImage.TYPE_INT_ARGB),new Point(0,0),"NO_CURSOR");
      }
      else
      {
         NO_CURSOR = null;
      }
   }
   
  /*******************************
   *   Init the game parameters  *
   ******************************/
  private void initGame()
  {
    iSpeed = 15 ;
    iSeconds = 0 ;
    iOldSeconds = 0 ;     
    g2 = panelCenter.getGraphics() ;    
    g3 = (Graphics2D) g2;    
    x = iPanelWidth/2 ;
    y = iPanelHeight-40 ;
    posY = y-20 ;
    barrPosX = x - (iRaqSize/2) ;
    barr.x = barrPosX ;
    barrRect = new Rectangle(barrPosX-4,y-30,70,30);
    ptBall = new Point(posX, posY) ;    
    drawBarr(barrPosX);
    posX = barr.x+(iRaqSize/2) ;
    drawBall(true);
    frame.setTitle("Forms JavaBean Wall-Brick     [level "+iCurrentLevel+"]");
    re_paint();
    if(!readFile(iCurrentLevel))
      {
        System.out.println("Error reading level");
        JOptionPane.showMessageDialog(this, "Unable to open the "+sCfgFile+" configuration file", "Error", JOptionPane.ERROR_MESSAGE);
        frame.setVisible(false);
      }

    //repaint();
    re_paint();
    
  }
 
  /************************
   *  Status bar message  *
   ***********************/
  private void DisplayStatus(String sMsg)
  {
    String msg="" ;
    if(!sMsg.equals(""))
    {
      sStatus = sMsg ;
      msg = sMsg ;
    }
    else msg=sStatus ;
    statusBar.setText(msg + "             ["+iLifes+" lifes]");
  }
 
 /*******************
  *  Draw the barr  *
  ******************/
  private void drawBarr( int xPos )
  {
    if( oldBarrX > -1)
    {
       g2.setColor( bgColor ) ;
       g2.fillRect(oldBarrX-3,y-14,70,18);         
    }
    barr.x = (xPos < iPanelWidth-iRaqSize ? xPos : iPanelWidth-iRaqSize);
    oldBarrX = barr.x ;
    if(icBarr != null) icBarr.paintIcon(this,g2,barr.x,y-11);
  }
  
 /*******************
  *  Draw the ball  *
  ******************/
 private void drawBall(boolean bForce)
 {
    if(bForce || ! barrRect.contains(ptBall) )
    {
      g2.setColor(bgColor);
		  g2.fillOval(oldx-2,oldy-2,14,14);
		  g2.setColor(cBarr);
		  g2.fillOval(posX-5,posY-5,10,10);
      oldx = posX-5 ; oldy = posY-5 ;
    }
    if(posY > y-50) drawBarr(barr.x);
    ptBall = new Point(posX, posY) ;    
    // repaint the nearest bricks
    if( bStart && (iGridX < iMaxCols && iGridY < iMaxLines))
    {
      if( iSens > 0 )
      {
        drawBrick( iGridX-1, iGridY-1 ) ;
        drawBrick( iGridX  , iGridY-1 ) ;
        drawBrick( iGridX+1, iGridY-1 ) ;
      }
      else
      {
        drawBrick( iGridX-1, iGridY+1 ) ;
        drawBrick( iGridX  , iGridY+1 ) ;
        drawBrick( iGridX+1, iGridY+1 ) ;              
      }
      drawBrick( iGridX-1, iGridY ) ;
      drawBrick( iGridX+1, iGridY ) ;      
    }
 }
 
 /******************
  *  Draw a brick  *
  *****************/
  private void drawBrick( int col, int lig )
  {
     if( (col >=0 && col < iMaxCols) && (lig >=0 && lig < iMaxLines) )
     {
      if( (vBricks[lig][col].iType > 0) && tbBricks[vBricks[lig][col].iType] != null )
      {
        tbBricks[vBricks[lig][col].iType].paintIcon(this,g2,vBricks[lig][col].x,vBricks[lig][col].y);
      }    
     }
  }

 /******************
  *  Hide a brick  *
  *****************/
  private void hideBrick( int x, int y )
  {
     g2.setColor( bgColor ) ;
     g2.fillRect(vBricks[x][y].x,vBricks[x][y].y,vBricks[x][y].w,vBricks[x][y].h);
  }
  
  /*******************************
   *  Ouput messages on console  *
   ******************************/
  private void log( String msg)
  {
     if( bLog ) System.out.println(msg) ;
  }
 
  private int myRandomInteger(int min, int max) 
  { 
    return (int) (min + Math.random() * (max - min + 1)); 
  }
  
  /***********************************************
   *  run the move() function in its own thread  *
   **********************************************/
   private void startMove()
    {
      if (runner == null )
      {
        runner = new Thread(this);
        runner.start();
      }
    }
 
  /***************************
   *  Load the bricks icons  *
   **************************/
   private void loadIcons()
   {
      tbBricks[1] = new ImageIcon("bt_vert.jpg");
      tbBricks[2] = new ImageIcon("bt_bleu.jpg");
      tbBricks[3] = new ImageIcon("bt_rouge.jpg");
      tbBricks[6] = new ImageIcon("bt_violet.jpg");
      tbBricks[7] = new ImageIcon("bt_jaune.jpg");
      tbBricks[9] = new ImageIcon("bt_ocre.jpg");
   }
  
   /********************************************
   *  Load an image from the current JAR file  *
   ********************************************/
   private Image loadImage(String imageName)
   {
     URL imageURL = null;
     boolean loadSuccess = false;
     Image img = null ;

     imageURL = getClass().getResource(imageName);
     if (imageURL != null)
     {
       try
       {
         img = Toolkit.getDefaultToolkit().getImage(imageURL);
         loadSuccess = true;
       }
       catch (Exception ilex)
       {
         log("Error loading image from JAR: " + ilex.toString());
       }
     }
     else
     {
       log("Unable to find " + imageName + " in JAR");
     }
     return img ;
   }
   
 public void run()
 {
    move(); 
 }

  public static void main(String[] args)
  {
    try
    {
      UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
    }
    catch(Exception e)
    {
      e.printStackTrace();
    }

    new Jbrick();
  }
}